<!-- 
QuizHTML5 es una aplicacin creada por Fernando Posada de canalTIC.com en abril-2014 para uso educativo.
Licencia de uso: http://creativecommons.org/licenses/by-nc-sa/4.0/ 
-->
<html>
    <head>
    	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
    	<link rel="shortcut icon" href="img/favicon.ico" />
			<link rel="stylesheet" href="css/styles.css" type="text/css">
			<title>QuizHTML5</title>
<script>
window.onload = start;
 function start(){
    var canvas = document.getElementById("myCanvas");
    var context = canvas.getContext("2d");
		var quizbg = new Image();
		var Question = new String;
	  var Option1 = new String;
		var Option2 = new String;
		var Option3 = new String;
		var Option4 = new String;
		var AnswerOK = new String;
		var mx=0;
		var my=0
		var qnumber = -1;
		var rightanswers=0;
		var wronganswers=0;
		var QuizFinished = false;
		var QuizStarted = false;
		var lock = true;
		var textpos0=30;
		var textpos1=70;
		var textpos2=160;
		var textpos3=210;
		var textpos4=260;
		var textpos5=310;
		var textpos6=365;
		var Questions = new Array;
		var Options = new Array;
		var CorrectAnswer = new Array;
		var sTimer = "00:00";
		var secTime = 0;
		var minTime = 0;
		var id;
<?php
// Load data
	if (isset($_GET["quiz"])) {
			$datastr = $_GET["quiz"] . ".jqz";
	} else {
      $datastr = "jquiz.jqz";
      }
       			
	$xml = simplexml_load_file($datastr);
	echo "var sTitle='". trim($xml-> data-> title) . "';";
  echo "\n"; 
  $counter= count($xml->data->questions->{'question-record'});
       			
	$limitedQuestions = $xml->{'hotpot-config-file'}->{'jquiz'}->{'show-limited-questions'};
	if ($limitedQuestions == "1") {
		$questiontoShow = $xml->{'hotpot-config-file'}->{'jquiz'}->{'questions-to-show'};
		if ($questiontoShow > $counter) {
			$questiontoShow = $counter;
		}
	} else {
		$questiontoShow = $counter;
	}
       		  
	$n = range(0, $counter-1);
	shuffle($n);
	$i=0;
	while ($i<$questiontoShow) {
		echo "Questions[".$i."]='". html_entity_decode($xml->data->questions->{'question-record'}[$n[$i]]->question) ."';";
		echo "\n";
		$counter2= count($xml->data->questions->{'question-record'}[$n[$i]]->answers->answer);
		$ok = 0;
		for($j=0;$j<$counter2;$j++){
			$answer = html_entity_decode(trim($xml->data->questions->{'question-record'}[$n[$i]]->answers->answer[$j]->text));
			if ($answer !='' && $ok<4) {
				if ($ok==0) {
					echo "Options[".$i."]=['". $answer ."'";
				} else {
					echo ",'". $answer ."'";
				}
				$isCorrect = $xml->data->questions->{'question-record'}[$n[$i]]->answers->answer[$j]->correct;
       	if ($isCorrect ==1) {
					$isCorrectIndex = $ok;
				}
				$ok++;
			}
		}
   	echo "];";		
		echo "\n";
		echo "CorrectAnswer[".$i."]=". $isCorrectIndex .";";
		echo "\n";
		$i++;
	} 
?>

quizbg.onload = function(){
	
	context.drawImage(quizbg, 0, 0);
	context.drawImage(quizbg, 36,441,225,30,160,180,225,30);
	context.textBaseline = "middle";
	context.textAlign="left";
	context.font = "14pt Calibri,Arial";
	context.fillText("Comenzar",230,195);
	context.textAlign="center";
	context.fillText(sTitle,260,textpos6-5);
	context.textAlign="right";
	context.font = "10pt Calibri,Arial";
	context.fillText(String(rightanswers),462,textpos6);
	context.fillText(String(rightanswers+wronganswers),490,textpos6);
	context.fillText(sTimer,532,textpos6);
}
//quizbg onload

				
function wrapText(context, text, x, y, maxWidth, lineHeight) {
	
        var cars = text.split("\n");

        for (var ii = 0; ii < cars.length; ii++) {

            var line = "";
            var words = cars[ii].split(" ");

            for (var n = 0; n < words.length; n++) {
                var testLine = line + words[n] + " ";
                var metrics = context.measureText(testLine);
                var testWidth = metrics.width;

                if (testWidth > maxWidth) {
                    context.fillText(line, x, y);
                    line = words[n] + " ";
                    y += lineHeight;
                }
                else {
                    line = testLine;
                }
            }

            context.fillText(line, x, y);
            y += lineHeight;
        }
     }
 // wrapText

function Shuffle(InArray){
	
	var Num;
	var Temp = new Array();
	var Len = InArray.length;

	var j = Len;

	for (var i=0; i<Len; i++){
		Temp[i] = InArray[i];
	}

	for (i=0; i<Len; i++){
		Num = Math.floor(j  *  Math.random());
		InArray[i] = Temp[Num];

		for (var k=Num; k < (j-1); k++) {
			Temp[k] = Temp[k+1];
		}
		j--;
	}
	return InArray;
}
//Shuffle

function SetQuestions(){
	
	Question=Questions[qnumber];
	AnswerOK  = Options[qnumber][CorrectAnswer[qnumber]];

	Options[qnumber]  = Shuffle (Options[qnumber]);
					
	Option1 = Options[qnumber][0] ;
	Option2 = Options[qnumber][1];
	Option3 = Options[qnumber][2];
	Option4 = Options[qnumber][3];
	if (Option3 == undefined) { Option3 = '';}
	if (Option4 == undefined) { Option4 = '';}

	context.textBaseline = "middle";
	context.textAlign="left";
	context.font = "10pt Calibri,Arial";
	context.fillText("Pregunta " + (qnumber+1) + " de " + Questions.length,20,textpos0);
	context.font = "14pt Calibri,Arial";
	wrapText(context, Question, 20, textpos1, 510, 24);
	context.drawImage(quizbg, 36,405,506,30,20,textpos2-15,506,30);
					
	context.font = "14pt Calibri,Arial";
	context.fillText(Option1,42,textpos2);
	context.drawImage(quizbg, 36,405,506,30,20,textpos3-15,506,30);
	context.fillText(Option2,42,textpos3);
	context.drawImage(quizbg, 36,405,506,30,20,textpos4-15,506,30);
	context.fillText(Option3,42,textpos4);
	context.drawImage(quizbg, 36,405,506,30,20,textpos5-15,506,30);
	context.fillText(Option4,42,textpos5);
			
	context.textAlign="center"
	context.fillText(sTitle,260,textpos6-5);
	context.textAlign="right";
	context.font = "10pt Calibri,Arial";
	context.fillText(String(rightanswers),462,textpos6);
	context.fillText(String(rightanswers+wronganswers),490,textpos6);
	context.fillText(sTimer,532,textpos6);
}
//SetQuestions

function ProcessClick(ev) {

				mx=ev.x-canvas.offsetLeft;
				my=ev.y-canvas.offsetTop;
				
				if(ev.x == undefined){
					mx = ev.pageX - canvas.offsetLeft;
					my = ev.pageY - canvas.offsetTop;
				}
				if (!QuizStarted) { 
						QuizStarted = true; 
						goTime();
						}
			
			if(lock){
				ResetQ();
			}//if lock
			else{
					if(QuizFinished) {
						window.location.reload();
		  		}
		  		else {
			if(my>140 && my<180){GetFeedback(0);}
			if(my>190 && my<230){GetFeedback(1);}
			if(my>240 && my<280){GetFeedback(2);}
			if(my>290 && my<330){GetFeedback(3);}
			 }
			}//!lock
}
//ProcessClick
				
function showTime () {
	++secTime;
	sTimer = "";
	if(secTime==60) { secTime=0; ++minTime }
	if(minTime<10) sTimer+="0";
	sTimer+=minTime;
	sTimer+=":";
	if(secTime<10) sTimer+="0";
	sTimer+=secTime;
	context.textAlign="right";
	context.font = "10pt Calibri,Arial";
	context.fillStyle = "#D4D0C8";
  context.fillRect(500,textpos6-5, 32,10);
	context.fillStyle = "#000000";
	context.fillText(sTimer,532,textpos6);
}
//ShowTime

function goTime() {
	 id=setInterval(function(){showTime()},1000);
}
function stopTime() { 
	clearInterval(id) 
}


function GetFeedback (a) { 
		  if(Options[qnumber][a]== AnswerOK){
		  	context.drawImage(quizbg, 0,405,14,14,25,152+(50*a),14,14);
			rightanswers++;
			//drawImage(image, sx, sy, sWidth, sHeight, dx, dy, dWidth, dHeight)
		  }
		  else{
		    context.drawImage(quizbg, 20,405,14,14,25,152+(50*a),14,14);
			wronganswers++;
		  }
		  lock=true;
		  context.drawImage(quizbg, 36,441,225,30,305,16,225,30);
		  context.font = "12pt Calibri,Arial";
		  context.textAlign="left";
		  context.fillText("Clic de nuevo para continuar",323,32);
}
// GetFeedback


function ResetQ() {
		lock=false;
		context.clearRect(0,0,550,400);
		qnumber++;
		if(qnumber==Questions.length){EndQuiz();}
		else{
		context.drawImage(quizbg, 0, 0);
		SetQuestions();
	  }
}
// ResetQ

function EndQuiz () {
		QuizFinished = true;
		stopTime();
		context.drawImage(quizbg, 0, 0);
		context.font = "14pt Calibri,Arial";
		context.textAlign="left";
		context.fillText("Finalizado",30,40);
		context.textAlign="center"
		context.fillText(sTitle,260,textpos6-5);
		context.textAlign="left";
		context.font = "12pt Calibri,Arial";
		context.fillText("- Aciertos: "+String(rightanswers)+" ("+ String(Math.floor(rightanswers*100/Questions.length)) +"%)",40,80);
		context.fillText("- Errores: "+String(wronganswers)+" ("+ String(Math.floor(wronganswers*100/Questions.length)) +"%)",40,100);
		context.fillText("- Preguntas: "+String(Questions.length),40,120);
		context.fillText("- Tiempo invertido: "+sTimer,40,140);
		context.drawImage(quizbg, 36,441,225,30,160,180,225,30);
	  context.textBaseline = "middle";
	  context.textAlign="left";
		context.font = "14pt Calibri,Arial";
		context.fillText("Nuevo intento",220,195);
	  context.textAlign="right";
		context.font = "10pt Calibri,Arial";
		context.fillText(String(rightanswers),462,textpos6);
		context.fillText(String(rightanswers+wronganswers),490,textpos6);
		context.fillText(sTimer,532,textpos6);
		}
		// EndQuiz
	
quizbg.src = "img/quizbg.png";
canvas.addEventListener('click',ProcessClick,false);

	};
	//start Function
</script>
</head>

<body>
<div id="ccontainer">
<canvas id="myCanvas" width="550" height="400"></canvas>
</div>
</body>
</html>